import { couple, deepComparison, extractDirectedRelation, getId, getList } from './helpers.js';
export const afterListChange = (config, direction)=>async ({ originalDoc, value, previousValue, req, context })=>{
        if (value && originalDoc && value !== previousValue) {
            if (previousValue && deepComparison(value, previousValue)) return null;
            const { there } = extractDirectedRelation(config, direction);
            const deletedEntries = previousValue?.filter((oldEntry)=>value.filter((newEntry)=>getId(oldEntry[there.field]) === getId(newEntry[there.field])).length == 0) ?? [];
            await couple(originalDoc, deletedEntries, config, direction, req, 'decoupling', context);
            await couple(originalDoc, value, config, direction, req, 'recoupling', context);
        }
        return null;
    };
export const afterDocumentDelete = (config, direction)=>async ({ doc, req, context })=>couple(doc, getList(config, direction, doc), config, direction, req, 'decoupling', context);

//# sourceMappingURL=hooks.js.map